% solution of longitudnal equations of motion(fixed stick)

% loading the m file "data"

data

% writing the solution matrix derived from the simplified 
% equations of longitudnal motion

%       u(s)                 alpha(s)                   theta(s)
A = [(m*U/(S*q))*s-Cxu      -Cxalpha              -Cw*cos(theta);
     -Czu              (m*U/(S*q))*s-Czalpha      (-m*U/(S*q))*s-Cw*sin(theta)
     0                  -d*Cmalphad*s-Cmalpha   (Iyy/(S*q*c))*s^2-d*Cmq*s
     ];

 eq = sym2poly(det(A)); % to obtain a 4th deg poly
 r = roots(eq); % to find the roots of the above equation
 f1 = conv([1 -r(1)], [1 -r(2)]);%multiplying conjugates to obtain factor 1
 f2 = conv([1 -r(4)], [1 -r(3)]);%multiplying conjugates to obtain factor 2
 
% OBTAINING THE LONGITUDNAL TRANSFER FUNCTIONS

den = sym2poly(det(A));
R=[Cxdel Czdel Cmdel]';

% tf = u(s)/delta(s)

M1=[R A(:,2) A(:,3)];
num1 = sym2poly(det(M1));

utf = tf(num1,den);
% bode(utf);
% figure;impulse(-6*utf);

% tf = alpha(s)/delta(s)

M2=[A(:,1) R A(:,3)];
num2 = sym2poly(det(M2));

alphatf = tf(num2,den)
% figure;bode(alphatf);
% figure;impulse(-6*alphatf);

% tf = theta(s)/delta(s)

M3=[A(:,1) A(:,2) R];
num3 = sym2poly(det(M3));

thetatf = tf(num3,den);
% figure;bode(thetatf);
% figure;impulse(-6*thetatf);
