/* Include files */
#include "demodualatorpsk_sfun.h"
#include "c2_demodualatorpsk.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "demodualatorpsk_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c2_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc2_demodualatorpskInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c2_demodualatorpsk(void);
static void initialize_params_c2_demodualatorpsk(void);
static void enable_c2_demodualatorpsk(void);
static void disable_c2_demodualatorpsk(void);
static void finalize_c2_demodualatorpsk(void);
static void sf_c2_demodualatorpsk(void);
static real_T *c2_u(void);
static real_T *c2_a(void);
static real_T *c2_v(void);
static real_T *c2_b(void);
static real_T *c2_c(void);

/* Function Definitions */
static void initialize_c2_demodualatorpsk(void)
{
  chartInstance.c2_is_active_c2_demodualatorpsk = 0U;
}

static void initialize_params_c2_demodualatorpsk(void)
{
}

static void enable_c2_demodualatorpsk(void)
{
}

static void disable_c2_demodualatorpsk(void)
{
}

static void finalize_c2_demodualatorpsk(void)
{
}

static void sf_c2_demodualatorpsk(void)
{
  uint8_T c2_previousEvent;
  real_T c2_b_u;
  real_T c2_b_v;
  real_T c2_b_c;
  real_T c2_b_b;
  real_T c2_b_a;
  boolean_T c2_em_b0;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK(*c2_u(), 3U);
  _SFD_DATA_RANGE_CHECK(*c2_a(), 4U);
  _SFD_DATA_RANGE_CHECK(*c2_v(), 0U);
  _SFD_DATA_RANGE_CHECK(*c2_b(), 1U);
  _SFD_DATA_RANGE_CHECK(*c2_c(), 2U);
  c2_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  c2_b_u = *c2_u();
  c2_b_v = *c2_v();
  sf_debug_push_symbol_scope(5U);
  sf_debug_symbol_scope_add_symbol("c", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   &c2_b_c);
  sf_debug_symbol_scope_add_symbol("b", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   &c2_b_b);
  sf_debug_symbol_scope_add_symbol("a", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   &c2_b_a);
  sf_debug_symbol_scope_add_symbol("v", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   &c2_b_v);
  sf_debug_symbol_scope_add_symbol("u", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   &c2_b_u);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,6);
  if(CV_EML_COND(0, 0, c2_b_u > -0.6) && CV_EML_COND(0, 1, c2_b_u < -0.4)) {
    c2_em_b0 = true;
  } else {
    c2_em_b0 = false;
  }
  if(CV_EML_IF(0, 0, CV_EML_MCDC(0, 0, c2_em_b0))) {
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
    c2_b_a = 1.0;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
    c2_b_b = 1.0;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,10);
  c2_b_a = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,11);
  c2_b_b = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,12);
  c2_b_c = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-12);
  sf_debug_pop_symbol_scope();
  *c2_a() = c2_b_a;
  *c2_b() = c2_b_b;
  *c2_c() = c2_b_c;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c2_previousEvent;
  sf_debug_check_for_state_inconsistency();
}

static real_T *c2_u(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real_T *c2_a(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real_T *c2_v(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real_T *c2_b(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
}

static real_T *c2_c(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
}

/* SFunction Glue Code */
void sf_c2_demodualatorpsk_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1741036694U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2397499164U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1141183756U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1922167983U);
}

mxArray *sf_c2_demodualatorpsk_get_autoinheritance_info(void)
{
  const char *autoinheritanceInfoStructFieldNames[] =
  {"checksum","inputSizes","inputTypes","inputComplexities","parameterSizes","parameterTypes","parameterComplexities","outputSizes","outputTypes","outputComplexities"};
  mxArray *mxAutoinheritanceInfo = NULL;
  mxArray *mxChecksum = NULL;
  mxArray *mxInputSizes = NULL;
  mxArray *mxInputTypes = NULL;
  mxArray *mxInputComplexities = NULL;
  mxArray *mxParameterSizes = NULL;
  mxArray *mxParameterTypes = NULL;
  mxArray *mxParameterComplexities = NULL;
  mxArray *mxOutputSizes = NULL;
  mxArray *mxOutputTypes = NULL;
  mxArray *mxOutputComplexities = NULL;

  mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,
   sizeof(autoinheritanceInfoStructFieldNames)/sizeof(char *),
   autoinheritanceInfoStructFieldNames);

  mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
  ((real_T *)mxGetPr((mxChecksum)))[0] = (real_T)(1974837968U);
  ((real_T *)mxGetPr((mxChecksum)))[1] = (real_T)(1868346271U);
  ((real_T *)mxGetPr((mxChecksum)))[2] = (real_T)(3187156238U);
  ((real_T *)mxGetPr((mxChecksum)))[3] = (real_T)(3936266757U);

  mxInputSizes = mxCreateDoubleMatrix(2,2,mxREAL);
  mxInputTypes = mxCreateDoubleMatrix(1,2,mxREAL);
  mxInputComplexities = mxCreateDoubleMatrix(1,2,mxREAL);
  ((real_T *)mxGetPr((mxInputSizes)))[0] = (real_T)(1U);
  ((real_T *)mxGetPr((mxInputSizes)))[1] = (real_T)(1U);
  ((real_T *)mxGetPr((mxInputTypes)))[0] = (real_T)(10U);
  ((real_T *)mxGetPr((mxInputComplexities)))[0] = (real_T)(0U);
  ((real_T *)mxGetPr((mxInputSizes)))[2] = (real_T)(1U);
  ((real_T *)mxGetPr((mxInputSizes)))[3] = (real_T)(1U);
  ((real_T *)mxGetPr((mxInputTypes)))[1] = (real_T)(10U);
  ((real_T *)mxGetPr((mxInputComplexities)))[1] = (real_T)(0U);

  mxParameterSizes = mxCreateDoubleMatrix(2,0,mxREAL);
  mxParameterTypes = mxCreateDoubleMatrix(1,0,mxREAL);
  mxParameterComplexities = mxCreateDoubleMatrix(1,0,mxREAL);

  mxOutputSizes = mxCreateDoubleMatrix(2,3,mxREAL);
  mxOutputTypes = mxCreateDoubleMatrix(1,3,mxREAL);
  mxOutputComplexities = mxCreateDoubleMatrix(1,3,mxREAL);
  ((real_T *)mxGetPr((mxOutputSizes)))[0] = (real_T)(1U);
  ((real_T *)mxGetPr((mxOutputSizes)))[1] = (real_T)(1U);
  ((real_T *)mxGetPr((mxOutputTypes)))[0] = (real_T)(10U);
  ((real_T *)mxGetPr((mxOutputComplexities)))[0] = (real_T)(0U);
  ((real_T *)mxGetPr((mxOutputSizes)))[2] = (real_T)(1U);
  ((real_T *)mxGetPr((mxOutputSizes)))[3] = (real_T)(1U);
  ((real_T *)mxGetPr((mxOutputTypes)))[1] = (real_T)(10U);
  ((real_T *)mxGetPr((mxOutputComplexities)))[1] = (real_T)(0U);
  ((real_T *)mxGetPr((mxOutputSizes)))[4] = (real_T)(1U);
  ((real_T *)mxGetPr((mxOutputSizes)))[5] = (real_T)(1U);
  ((real_T *)mxGetPr((mxOutputTypes)))[2] = (real_T)(10U);
  ((real_T *)mxGetPr((mxOutputComplexities)))[2] = (real_T)(0U);

  mxSetFieldByNumber(mxAutoinheritanceInfo,0,0,mxChecksum);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,1,mxInputSizes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,2,mxInputTypes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,3,mxInputComplexities);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,4,mxParameterSizes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,5,mxParameterTypes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,6,mxParameterComplexities);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,7,mxOutputSizes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,8,mxOutputTypes);
  mxSetFieldByNumber(mxAutoinheritanceInfo,0,9,mxOutputComplexities);

  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S)
{
  if(ssIsFirstInitCond(S)) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_demodualatorpskMachineNumber_,
         2,
         1,
         1,
         5,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_demodualatorpskMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_demodualatorpskMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0.0,1.0,0,"u",0);
          _SFD_SET_DATA_PROPS(4,2,0,1,SF_DOUBLE,0,NULL,0,0.0,1.0,0,"a",0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0.0,1.0,0,"v",0);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0.0,1.0,0,"b",0);
          _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,0,NULL,0,0.0,1.0,0,"c",0);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,187);
        _SFD_CV_INIT_EML_IF(0,0,131,153,-1,171);
        {
          static int condStart[] = {135,146};
          static int condEnd[] = {142,152};
          static int pfixExpr[] = {0,1,-3};
          _SFD_CV_INIT_EML_MCDC(0,0,135,152,2,0,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(3U, c2_u());
        _SFD_SET_DATA_VALUE_PTR(4U, c2_a());
        _SFD_SET_DATA_VALUE_PTR(0U, c2_v());
        _SFD_SET_DATA_VALUE_PTR(1U, c2_b());
        _SFD_SET_DATA_VALUE_PTR(2U, c2_c());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_demodualatorpskMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c2_demodualatorpsk(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S);
  initialize_params_c2_demodualatorpsk();
  initialize_c2_demodualatorpsk();
}

static void sf_opaque_enable_c2_demodualatorpsk(void *chartInstanceVar)
{
  enable_c2_demodualatorpsk();
}

static void sf_opaque_disable_c2_demodualatorpsk(void *chartInstanceVar)
{
  disable_c2_demodualatorpsk();
}

static void sf_opaque_gateway_c2_demodualatorpsk(void *chartInstanceVar)
{
  sf_c2_demodualatorpsk();
}

static void sf_opaque_terminate_c2_demodualatorpsk(void *chartInstanceVar)
{
  finalize_c2_demodualatorpsk();
}

static void mdlProcessParameters_c2_demodualatorpsk(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    ssUpdateDlgParamAsRunTimeParam(S, i);
  }
  initialize_params_c2_demodualatorpsk();
}

static void mdlSetWorkWidths_c2_demodualatorpsk(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("demodualatorpsk",2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("demodualatorpsk",2,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"demodualatorpsk",2,2);
      sf_mark_chart_reusable_outputs(S,"demodualatorpsk",2,3);
    }
    if (!sf_is_chart_instance_optimized_out("demodualatorpsk",2)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("demodualatorpsk",2);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1741036694U));
  ssSetChecksum1(S,(2397499164U));
  ssSetChecksum2(S,(1141183756U));
  ssSetChecksum3(S,(1922167983U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c2_demodualatorpsk(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "demodualatorpsk", 2);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_demodualatorpsk(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c2_demodualatorpsk;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c2_demodualatorpsk;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c2_demodualatorpsk;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c2_demodualatorpsk;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c2_demodualatorpsk;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c2_demodualatorpsk;
  chartInstance.chartInfo.mdlStart = mdlStart_c2_demodualatorpsk;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c2_demodualatorpsk;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */
}

void c2_demodualatorpsk_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_demodualatorpsk(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_demodualatorpsk(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_demodualatorpsk(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c2_demodualatorpsk_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

