M = input('enter mach number :    ')
var=input('enter model  :  ')
switch(var)
    case(18)
model_18
    case(17)
        model_17
         case(16)
        model_16
         case(15)
        model_15
         case(14)
        model_14
         case(13)
        model_13
         case(12)
        model_12
         case(11)
        model_11
         case(10)
        model_10
         case(9)
        model_9
         case(8)
        model_8
         case(7)
        model_7
         case(6)
        model_6
         case(5)
        model_5
         case(4)
        model_4
         case(3)
        model_3
         case(2)
        model_2
         case(1)
        model_1
        
end

%variation of pressure distribution with s/d

pu_pt2 = (((7.*M.^2)-1)/6).^2.5.*(5/(6.* M.^2)).^3.5;
pt2_pu = 1/pu_pt2;
pu = 101325;
d_rn =1/rn_d;
pu_pt2 = 1/pt2_pu;
s_d = 0:0.01:0.8;
pl_pt2 = (cos(s_d.*d_rn)).^2 + (pu_pt2).*(sin(s_d.*d_rn)).^2;
figure
plot(s_d,pl_pt2);hold on 
xlabel('s / d','FontSize',16)
ylabel('p_l / p_t_2','FontSize',16)
title('variaiton of pressure distribution with s/d','FontSize',16)
axis([0 0.8 0 1.2])

% VELOCITY DISTRIBUTION:
pt2 = (pt2_pu).*pu                         %stagnation pressure
pl = (pl_pt2).*pt2
rou = 1.229;

u = sqrt((2.*(pt2 - pl))/rou);              %using Bernoullis equation

tstar_tt = 0.833;
tt = input('enter tt (if M= 2.49 and 3.51, tt = 339 and if M = 4.06 and 4.63, tt = 353)'       );
tstar = tstar_tt  * tt

astar = sqrt(1.4*287*tstar)

u_astar = u./astar;                         %non dimensionalised velocity

figure
plot(s_d,u_astar)
xlabel('s / d','FontSize',16)
ylabel('u / a*','FontSize',16)
title('variaiton of velocity distribution with s/d','FontSize',16)


%Variation of drag coefficient with Mach number
Mi= 1:0.1:8
Cp_max = (1.428./Mi.^2).*((((5.76.*Mi.^2)/(5.6.*Mi.^2-0.8)).^3.5 .* ((-0.4+2.8 .* Mi.^2)/2.4))-1)
Cd_M = Cp_max./2 + 1./(Mi.^2)
Cd_M1 = Cp_max./2
figure
plot(Mi,Cp_max)
xlabel('Mach Number','FontSize',16)
ylabel('Cp_m_a_x','FontSize',16)
title('Cp_m_a_x Variaiton with Mach number','FontSize',16)
figure
plot(Mi,Cd_M)
hold on 
plot (Mi,Cd_M1)
xlabel('Mach Number','FontSize',16)
ylabel('C_d','FontSize',16)
title('C_d Variaiton with Mach number','FontSize',16)
axis([0 8 0 1.2])
clear all

%Variation of drag coefficient with rc/d
%For model no. 6 to 11
M = input('enter mach number :    ')
ala=zeros(1,5);
bla=zeros(1,5);
tla=zeros(1,5);
for(i=6:10)
   
   

    switch(i)
        case(10)
        model_10
         case(9)
        model_9
         case(8)
        model_8
         case(7)
        model_7
         case(6)
        model_6   
        
    end


d = 0.191;
rb = 0.191/2;       %radius of the base
rn = rn_d*0.191;      %radius of nose
rc = rc_d*0.191;      %shoulder radius
%Calculation of theta1 from geometry:
s1 = (s1_d)*d;
theta1 = s1/rn;

%calculating variation in drag coefficient with mach number

Cpb = -1*(1/M^2);


    Cp_max = (1.428./M.^2).*((((5.76.*M.^2)/(5.6.*M.^2-0.8)).^3.5 .* ((-0.4+2.8 .* M.^2)/2.4))-1)
    
    Cd = 0.5.*(rn./rb).^2*Cp_max.*(1 - (cos(theta1)).^4) + 2.*Cp_max .* (rc./rb).*(1-rc./rb).*(0.66 - 0.333.*sin(theta1)*((cos(theta1)).^2 + 2)) + .5.* Cp_max.*(rc./rb).^2.*(cos(theta1))^4 - Cpb
bla(i-5)=rc_d;
ala(i-5)=Cd 

end

figure
plot(bla, ala)
xlabel('r_c / d','FontSize',16)
ylabel('C_d','FontSize',16)
title('Drag coefficient variation for Models 6 - 10 ','FontSize',16)
axis([0 0.4 0 2])
clear all
%For model no. 11 to 14
M = input('enter mach number :    ')
ala1=zeros(1,5);
bla1=zeros(1,5);


for(i=11:14)
    switch(i)
        case(14)
        model_14
         case(13)
        model_13
         case(12)
        model_12
         case(11)
        model_11
     
    end
    
d = 0.191;
rb = 0.191/2;       %radius of the base
rn = rn_d*0.191;      %radius of nose
rc = rc_d*0.191;      %shoulder radius
%Calculation of theta1 from geometry:
s1 = (s1_d)*d;
theta1 = s1/rn;

%Drag Coefficient:

Cpb = -1*(1/M^2);
Cp_max = (1.428./M.^2).*((((5.76.*M.^2)/(5.6.*M.^2-0.8)).^3.5 .* ((-0.4+2.8 .* M.^2)/2.4))-1)
Cd = 0.5.*(rn./rb).^2*Cp_max.*(1 - (cos(theta1)).^4) + 2.*Cp_max .* (rc./rb).*(1-rc./rb).*(0.66 - 0.333.*sin(theta1)*((cos(theta1)).^2 + 2)) + .5.* Cp_max.*(rc./rb).^2.*(cos(theta1))^4 - Cpb
bla1(i-9)=rc_d;
ala1(i-9)=Cd 
axis([0 0.4 0 2])
end

figure

plot(bla1, ala1)
xlabel('r_c / d','FontSize',16)
ylabel('C_d','FontSize',16)
title('Drag coefficient variation for Models 11-14 ','FontSize',16)
clear all
% FOR MODEL NO. 15 AND 16
M = input('enter mach number :    ')

ala2=zeros(1,2);
bla2=zeros(1,2);

for(i=15:16)
    switch(i)
        case(16)
        model_16
         case(15)
        model_15
     
    end
    
d = 0.191;
rb = 0.191/2;       %radius of the base
rn = rn_d*0.191;      %radius of nose
rc = rc_d*0.191;      %shoulder radius

%Drag Coefficient:

Cpb = -1*(1/M^2);
Cp_max = (1.428./M.^2).*((((5.76.*M.^2)/(5.6.*M.^2-0.8)).^3.5 .* ((-0.4+2.8 .* M.^2)/2.4))-1)
Cd = 0.5.*(rn./rb).^2*Cp_max.*(1 - (cos(theta1)).^4) + 2.*Cp_max .* (rc./rb).*(1-rc./rb).*(0.66 - 0.333.*sin(theta1)*((cos(theta1)).^2 + 2)) + .5.* Cp_max.*(rc./rb).^2.*(cos(theta1))^4 - Cpb
bla2(i-14)=rc_d;
ala2(i-14)=Cd 
end

figure

plot(bla2, ala2)
xlabel('r_c / d','FontSize',16)
ylabel('C_d','FontSize',16)
title('Drag coefficient variation for Models 15 & 16  ','FontSize',16)
axis([0 0.2 0 2])
clear all
% FOR MODEL NO. 17
M = input('enter mach number :    ')

for(i=17)
    switch(i)
        case(17)
        model_17
    end
    
d = 0.191;
rb = 0.191/2;       %radius of the base
rn = rn_d*0.191;      %radius of nose
rc = rc_d*0.191;      %shoulder radius

%Drag Coefficient:
rc_d = 0:0.1:0.4
Cpb = -1*(1/M^2);
Cp_max = (1.428./M.^2).*((((5.76.*M.^2)/(5.6.*M.^2-0.8)).^3.5 .* ((-0.4+2.8 .* M.^2)/2.4))-1)
Cd = 0.5.*(rn./rb).^2*Cp_max.*(1 - (cos(theta1)).^4) + 2.*Cp_max .* (rc./rb).*(1-rc./rb).*(0.66 - 0.333.*sin(theta1)*((cos(theta1)).^2 + 2)) + .5.* Cp_max.*(rc./rb).^2.*(cos(theta1))^4 - Cpb

end

figure

plot(rc_d,Cd)
xlabel('r_c / d','FontSize',16)
ylabel('C_d','FontSize',16)
title('Drag coefficient variation for Models 17 ','FontSize',16)

clear all
%FOR MODEL NO. 1 TO 5
M = input('enter mach number :    ')
ala4=zeros(1,5);
bla4=zeros(1,5);

for(i=1:5)
    switch(i)
        case(5)
        model_5
         case(4)
        model_4
         case(3)
        model_3
         case(2)
        model_2
        case (1)
            model_1
     
    end
    
d = 0.191;
rb = 0.191/2;       %radius of the base
rn = rn_d*0.191;      %radius of nose
rc = rc_d*0.191;      %shoulder radius


Cpb = -1*(1/M^2);
Cp_max = (1.428./M.^2).*((((5.76.*M.^2)/(5.6.*M.^2-0.8)).^3.5 .* ((-0.4+2.8 .* M.^2)/2.4))-1)

Cd = (Cp_max.*(1- rc./rb).^2) + ((4/3.* Cp_max).*(rc./rb).*(1 - rc./rb)) + (0.5 .* Cp_max .* (rc./rb)^2) - Cpb


bla4(i)=rc_d;
ala4(i)=Cd 
end

figure

plot(bla4, ala4)
xlabel('r_c / d','FontSize',16)
ylabel('C_d','FontSize',16)
title('Drag coefficient variation for Models 1-5 ','FontSize',16)
axis([0 0.4 0 2])
clear all



% velocity distribution in stagnation region of models
% 

var1=input('enter the mach numer, choose a value: 2.5, 3.5 ,4.05 ,4.65  :  ');
switch(var1)
    case(2.5)
        machmodel_1
    case(3.5)
        machmodel_2
    case(4.05)
        machmodel_3
    case(4.65)
        machmodel_4
end

var=input('enter model  :  ')
switch(var)
    case(18)
model_18
    case(17)
        model_17
         case(16)
        model_16
         case(15)
        model_15
         case(14)
        model_14
         case(13)
        model_13
         case(12)
        model_12
         case(11)
        model_11
         case(10)
        model_10
         case(9)
        model_9
         case(8)
        model_8
         case(7)
        model_7
         case(6)
        model_6
         case(5)
        model_5
         case(4)
        model_4
         case(3)
        model_3
         case(2)
        model_2
         case(1)
        model_1
        
end


pu_pt2 = (((7.*M.^2)-1)/6).^2.5.*(5/(6.* M.^2)).^3.5;
pt2= 101325*(1/(pu_pt2));
rt = pt2/((T_t).*(287));

s_d = 0:0.05:0.8;
s = s_d .* 191;
theta = s_d .* (1./(rn_d))
pl_pt2 = (cos(theta)).^2 + (pu_pt2).* (sin(theta)).^2;

u = (theta).*(sqrt ((2.*(pt2./rt)).*(1-(pu_pt2))));
figure
plot (s,u)
grid
xlabel('s','FontSize',16)
ylabel('u','FontSize',16)
title('velocity distribution in stagnation region of models ','FontSize',16)
axis([0 60 0 160])

clear all

